-- Fd module for curry.
--
-- Copyright (C) 2005-2006, Babel Group
--
-- Written by: 
--   * Emilio Jesús Gallego Arias
--
-- This program is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

module Fd where

import engine Fdlib

infixl 6 .+., .-.
infix 4 .<., .>., .=<., .>=., .=., .<>., `in_range`

-- x in (1,2)
-- in conflicts with Curry reserved word in.
in_range :: Int -> (Int, Int) -> Success
in_range external

(.+.) :: Int -> Int -> Int
(.+.) external

(.-.) :: Int -> Int -> Int
(.-.) external

(.<.) :: Int -> Int -> Success
(.<.) external

(.=<.) :: Int -> Int -> Success
(.=<.) external

(.>:) :: Int -> Int -> Success
(.>:) external

(.>=.) :: Int -> Int -> Success
(.>=.) external

(.=.) :: Int -> Int -> Success
(.=.) external

(.<>.) :: Int -> Int -> Success
(.<>.) external

all_different :: [Int] -> [Int]
all_different external

labeling :: [Int] -> [Int]
labeling external
