module Coloring where

import Diseq

data Color = Red | Green | Yellow | Blue

c Red    = success
c Green  = success
c Yellow = success
c Blue   = success

-- We use square maps, and the neighborhood relation is just
-- horizontal and vertical.
-- data Map = [[Color]] We don't have type

map1 = [[x,y,z],[Blue,Red,Green],[x,y,z]] where x,y,z free
map2 = [[x,Green,z],[Blue,Red,Green],[x,y,z]] where x,y,z free

solve        :: [[Color]] -> Success
solve []     = success
solve (l:ls) = c_lists l ls & c_list l

c_lists          :: [Color] -> [[Color]] -> Success
c_lists l []     = success
c_lists l (x:xs) = foldr (&) success (map (\(a,b) -> a =/= b) (zip x l)) -- Use uncurry?

c_list            :: [Color] -> Success
c_list [x]        = success
c_list (x1:x2:xxs) = x1 =/= x2 & c_list (x2:xxs)

free_list :: Int -> [a]
free_list x = if x == 0 then 
                  [] 
              else
                  let le free in le:(free_list (x-1))

force_ground []     = success
force_ground (x:xs) = c x & force_ground xs

-- For testing in the shell try 
-- let x,y,z free in solve [[x,y,z],[Blue,Red,Green],[x,y,z]] 

-- The test for the benchmark should be something like.
-- let x = free_list 6 in solve [x] &> x
