#!/bin/bash

# Do testing with files.
SLOTH=$TOP/src/sloth-bin 
LIBDIR=`pwd`/$TOP/lib
SLOTH_OPTS="-v -l $LIBDIR"
#SLOTH_OPTS=
RES_FILE=$TOP/tests/tests_res.txt

CIAOC=ciaoc

check_results() {
    if diff -u $1.stdout $1.stdout.test >> $1.stderr.test
	then
	printf '\tTest %13s:\t\t OK!\n' $1
    else
	printf '\tTest %13s:\t\t FAIL!*****\n' $1
	#echo -e "Details:\n---------\n"
	#cat $1.stderr.test
	#echo -e "************************* Test $1 FAIL***********************************\n"
    fi | tee -a $RES_FILE
}

test_file() {
    errfile=$1.stderr.test
    echo -e "\n------ Compiling $1.curry to Prolog ----------"
    #echo -e "$SLOTH $SLOTH_OPTS $1.curry"
    $SLOTH $SLOTH_OPTS $1.curry 2> $errfile > /dev/null
    if grep -q 'main/0' $1.pl
	then
	echo -e "------ Compiling $1.pl to WAM ----------------"
    	$CIAOC -o $1.test $1.pl 2>> $errfile > /dev/null
    	echo -e "------ Executing $1 --------------------------"
    	./$1.test 2>> $1.stderr.test > $1.stdout.test 
    	check_results $1 
    else
	if test -f $1.pl 
	    then
	    echo -e "Module file compiled."
	else
	    check_results $1
	fi
    fi
}

case $1 in
    *.curry)
	test_file `echo $1 | cut -d. -f1`;;
    *)
	echo "$1 not a curry file";;
esac
